;
; mikie patch
; mailto:jp@drumfu.com
; november 2010 / june 2011 (see NOTE below)
;
; patch to original speedlock 1 version of mikie
; to run on +2A/B/3 et al - changes the value
; placed into the a register...
;
; original release
;
;	org $a7ac
;	di			 ; a7ac f3 $04ts
;	ld ($ff84), hl		 ; a7ad 22 84 ff $10ts
;	im 2			 ; a7b0 ed 5e $08ts
;	ld a, $39		 ; a7b2 3e 39 $07ts
;	ld i, a			 ; a7b4 ed 47 $09ts
;	ld hl, $a7c3		 ; a7b6 21 c3 a7 $0ats
;	ld de, $fff4		 ; a7b9 11 f4 ff $0ats
;	ld bc, $000c		 ; a7bc 01 0c 00 $0ats
;	ldir			 ; a7bf ed b0 $10/$15ts
;	ei			 ; a7c1 fb $04ts
;	ret			 ; a7c2 c9 $0ats
;
; hit squad release
;
;	org $a7ac
;	di			 ; a7ac f3 $04ts
;	ld ($ff84), hl		 ; a7ad 22 84 ff $10ts
;	im 2			 ; a7b0 ed 5e $08ts
;	ld a, $3b		 ; a7b2 3e 3b $07ts
;	ld i, a			 ; a7b4 ed 47 $09ts
;	ld hl, $a7c3		 ; a7b6 21 c3 a7 $0ats
;	ld de, $fff4		 ; a7b9 11 f4 ff $0ats
;	ld bc, $000c		 ; a7bc 01 0c 00 $0ats
;	ldir			 ; a7bf ed b0 $10/$15ts
;	ei			 ; a7c1 fb $04ts
;	ret			 ; a7c2 c9 $0ats
;
;
; this patch derived from jon north's series of hacking articles
; http://www.worldofspectrum.org/showwrap.cgi?page=hth61.html#speedlock1
;
;
; NOTE: This patch has been modified by Einar Saukas to also incorporate
; BadBeard's fix that prevents game from crashing when getting "perfect"
; rounds:
;
;       org $b2d7
;       call $e810		 ; b2d7 cd 10 e8
;       org $e810
;       di			 ; e810 f3
;       jp $aa92		 ; e811 c3 92 aa
;
;
	org $7530
;
main	ld ix,$5ccb
	ld de,$061a
	ld a,$ff
	scf
	call $0556	; load the basic block
	jr nc,main
;
	di
	ld hl,$5efd
	push hl
	ld de,$f812
	ld bc,$0269
	ld a,$c2
	ld r,a
	call $61fd	; run first decrypter
;
	ld hl,$f840
	ld de,$5f2b	; alternative location
	ld bc,$023b
;
	ld iy,$f840
	ld a,$fa
	set 7,a
	ld r,a
	call $f833	; run second decrypter
;
	pop hl
	ld ($f847),hl
	ld hl,$f88c	; force a ret rather than a jp z
	dec (hl)
;
	call $f840	; execute third decrypter
;
	ld hl,$f840	; now overwrite third decrypter
	ld ($fa49),hl	; force the loader to eventually jp here
;
	ld hl,pokes	; copy pokes to location
	ld de,$f840	; of third decrypter
	ld bc,endp-pokes
	ldir
;
	jp $fa14	; execute loader
;
pokes	ld a,$3b	; new a register value
	ld ($9ecb),a	; original location of ld a,$39
;
	ld hl,$e810     ; crash fix by BadBeard
	ld ($a9f0),hl
	ld hl,$c3f3
	ld ($df28),hl
	ld hl,$aa92
	ld ($df2a),hl
;
	jp $5b00	; execute post loader processing
endp	equ $		; end of pokes
;
	end
